﻿// InLineGraphicsInTable.jsx
// InDesign CS5
// © Иванюшин М.Ю., 2012  ivanyushin#yandex.ru
// Скрипт работает с записями в таблице, в которой сейчас курсор.
// Картинка подгоняется под размер ячейки, в которой найдено описание иллюстрации.
// Описание картинки -- отдельный однострочный абзац:  <Pict>Полное имя файла
//      *******
//
var myPictFileName;
var myTextFrame;
var myTextFrameWidth;
var myTextFrameHeight;
var myLine;
var myInfo;
var myLineWithTagAndPictName = new Array;
var myInsPt;
var myInsPtNextPara;
var myFound;
var myProgramTitul = "Замена в таблице абзаца с именем рисунка на сам рисунок. 16.02.2012    ";
///////
if (app.documents.length != 0)  { // app.doc 
var mySelection = app.selection[0];
var myDocument = app.documents.item(0);
var myTable = myCursorInTable();
if (myTable.parent.overflows == true) {
    alert("Переполнение текстового фрейма, в котором размещена выбранная для обработки таблица.",myProgramTitul);
    exit();
    }
var myTableHasPictureLinks = 0;
for (j = 0; j < myTable.cells.length; j++) { // myTable.cells.length
    var myCell = myTable.cells[j];
	myText = myTable.cells[j].texts[0]; 
    a=0;
	app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
	app.findTextPreferences.findWhat = "<Pict>"; 
    var myStory = myText;
    if (myText.length == 0) continue;
	myFound = myStory.findText();
    if (myFound.length == 1) { // myFound.length == 1
        myTableHasPictureLinks++;
        myPictureInCell(myCell);
        } // myFound.length == 1
} // myTable.cells.length
if (myTableHasPictureLinks == 0) { alert("В таблице нет абзацев, начинающихся с маркера описания рисунка <Pict>.",myProgramTitul); exit(); }
alert("Число записей, заменённых на картинки: " + myTableHasPictureLinks,myProgramTitul);
exit();
}// app.doc 
alert("Нет открытых документов.",myProgramTitul);
exit();
/////////
function myPictureInCell(myCell) { //myPictureInCell
myStory = myTable.cells[j].texts[0];
var myLine = myStory.paragraphs[0];
var myLineOriginal = myStory.paragraphs[0].contents; // на случай возврата содержимого ячейки, если объявленный там файл не будет найден
var myInsPt = myLine.length;
myStory.insertionPoints[myInsPt].contents = '>'; // добавим угловую скобку, чтобы выделить маршрут к иллюстрации. Если этого не сделать, в маршрут попадет знак перевода стоки, и иллюстрация не будет найдена.
myLineWithTagAndPictName = myLine.contents.split(">");
myLine.characters.itemByRange(myLine.length-2,myLine.length-2).remove(); // удалим введенную ранее угловую скобку
myPictFileName = File(myLineWithTagAndPictName[1]); 
var myPaper = myPictFileName.open("r");  
if (myPaper == false) { // myPaper == false
    myTableHasPictureLinks--;
    alert ("Файл " + decodeURI(myPictFileName)  +" не существует.\nЧисло записей, заменённых на картинки: " + myTableHasPictureLinks,myProgramTitul);
    myLine.characters.itemByRange(0,-1).remove();
    myStory.insertionPoints[0].select();
    myTable.cells[j].texts[0].contents = myLineOriginal;
    exit();
    } // myPaper == false	
myStory.paragraphs[0].characters.itemByRange(0,-1).remove(); // удалим строку с информацией о маршруте к иллюстрации. Останется только знак перевода строки
W = myCell.width - myCell.leftInset - myCell.rightInset;
H = myCell.height - myCell.topInset - myCell.bottomInset;
if (W < 0 || H < 0)  { alert ("Очень маленький фрейм",myProgramTitul); exit(); }
var myInLinePict = myStory.insertionPoints[0].rectangles.add();
myInLinePict.strokeWeight = 0;
with (myInLinePict) { geometricBounds = [0,0,H,W]; } 
try { myInLinePict.place(myPictFileName);} // помещаем в прямоугольник картинку 
catch (e) { // catch (e)
		// гипотетическая ситуация. при тестировании воспроизвести не удалось. И тем не менее оставлено на случай, что вдруг возникнет у кого из пользователей
		alert("Не удалось поместить рисунок.",myProgramTitul);
		myLastCharRemove();		
		exit(0);
	} // catch (e)	
var  myPicture = myInLinePict.allGraphics[0]; // ссылка на вставленную в прямоугольник иллюстрацию
myInLinePict.fit (FitOptions.PROPORTIONALLY);
myInLinePict.fit(FitOptions.CENTER_CONTENT);
myPicture.select();
app.cut();
myInLinePict.remove();
myStory.insertionPoints[0].select();
app.paste();
} //myPictureInCell
/////////////////////
function myCursorInTable () { // myCursorInTable
if(app.selection.length == 1) { // app.selection.length == 1
		if (mySelection.constructor.name == "Table")  return (mySelection);
		if (mySelection.parent.constructor.name == "Table") return (mySelection.parent);
		if (mySelection.parent.parent.constructor.name == "Table") return (mySelection.parent.parent);
		} // app.selection.length == 1
alert("Курсор должен быть в таблице или должна быть выделена хоть одна её ячейка.", myProgramTitul);
exit();
} // myCursorInTable
